function Create(self)

	self.jetOn = false;
	self.jetSwitchTimer = Timer();
	self.jetSwitchTime = 250;

	self.soundTimer = Timer();
	self.soundTime = 1000;

	self.flash = CreateMOSParticle("PackEffect","EAF.rte");
end

function Update(self)
	
	if not(self:IsDead()) and self.Health > 0 then
		if not self:HasObject("Claws") then
			Melee = CreateHDFirearm("Claws")
			self:AddInventoryItem(Melee)
		end
	end

	local ownController = self:GetController();

	if not(self:IsDead()) then
		if ownController:IsState(Controller.PRESS_UP) then
			if self.jetSwitchTimer:IsPastSimMS(self.jetSwitchTime) then
				self.jetSwitchTimer = Timer();
			else
				if self.jetOn then
					self.jetOn = false;
				else
					self.jetOn = true;
				end
			end
		end
	end

	if self.Health < 0 then
		self.jetOn = false;
	end

	if self.jetOn then
		
		jetFlash = CreateMOSParticle("Jump Jet Glow");
		jetFlash.Pos.Y = self.Pos.Y + 6;
		if not(self.HFlipped) then
			jetFlash.Pos.X = self.Pos.X - 16;
		else 
			jetFlash.Pos.X = self.Pos.X + 16;
		end
		MovableMan:AddParticle(jetFlash);

		
		if ownController:IsState(Controller.HOLD_LEFT) then
			self.Vel.X = self.Vel.X - 0.5;
		elseif ownController:IsState(Controller.HOLD_RIGHT) then
			self.Vel.X = self.Vel.X + 0.5;
		elseif not ownController:IsState(Controller.HOLD_LEFT) and not ownController:IsState(Controller.HOLD_RIGHT) then
			self.Vel.X = self.Vel.X / 1.2;
			if math.abs(self.Vel.X) < 2 then
				self.Vel.X = 0;
			end
		end

		if ownController:IsState(Controller.HOLD_DOWN) then
			self.Vel.Y = self.Vel.Y + 0.5;
		elseif ownController:IsState(Controller.HOLD_UP) then
			self.Vel.Y = self.Vel.Y - 0.75;
		elseif not ownController:IsState(Controller.HOLD_UP) and not ownController:IsState(Controller.HOLD_DOWN) then
			self.Vel.Y = self.Vel.Y / 1.2;
			if math.abs(self.Vel.Y) < 2 then
				self.Vel.Y = 0;
			end
		end

		if self.Vel.X > 15 then
			self.Vel.X = 15;
		elseif self.Vel.X < -15 then
			self.Vel.X = -15;
		end

		if self.Vel.Y > 15 then
			self.Vel.Y = 15;
		elseif self.Vel.Y < -15 then
			self.Vel.Y = -15;
		end

		if self.soundTimer:IsPastSimMS(self.soundTime) then
			self.soundTimer = Timer();
			self.jetSound = CreateAEmitter("Jet sound emmitter");
			self.jetSound.Pos = self.Pos;
			MovableMan:AddParticle(self.jetSound);
		end
		self.RotAngle = 0;
	end
end






